<ui:composition xmlns:g="http://www.ihe.net/gazelle" xmlns:gri="http://java.sun.com/jsf/composite/gri"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:a4j="http://richfaces.org/a4j" xmlns:rich="http://richfaces.org/rich"
                xmlns:gzl="http://java.sun.com/jsf/composite/gazelle-tags"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:define name="body">
        <h:form>
            <a4j:queue requestDelay="300" ignoreDupResponses="true"/>
            <gzl:div id="globalDiv">
                <h1>Application preferences</h1>
                <gri:panel rendered="#{applicationPreferenceManager.preference != null}">
                    <f:facet name="header">
                        #{messages['net.ihe.gazelle.simulator.common.NewApplicationPreference']}
                    </f:facet>
                    <ui:decorate template="/layout/form/_edit.xhtml">
                        <ui:param name="id" value="nameInput"/>
                        <ui:define name="label">#{messages['net.ihe.gazelle.simulator.common.PreferenceName']}
                        </ui:define>
                        <h:inputText value="#{applicationPreferenceManager.preference.variable}" id="nameInput"
                                     styleClass="form-control"/>
                    </ui:decorate>
                    <ui:decorate template="/layout/form/_edit.xhtml">
                        <ui:param name="id" value="valueInput"/>
                        <ui:define name="label">#{messages['net.ihe.gazelle.simulator.common.Value']}</ui:define>
                        <h:inputText value="#{applicationPreferenceManager.preference.value}" id="valueInput"
                                     styleClass="form-control"/>
                    </ui:decorate>
                    <f:facet name="footer">
                        <a4j:commandButton value="#{messages['users.Save']}"
                                           actionListener="#{applicationPreferenceManager.savePreference(applicationPreferenceManager.preference)}"
                                           render="globalDiv" styleClass="gzl-btn-green"/>
                        <a4j:commandButton value="#{messages['users.Cancel']}"
                                           actionListener="#{applicationPreferenceManager.setPreference(null)}"
                                           render="globalDiv" styleClass="gzl-btn-orange"/>
                    </f:facet>
                </gri:panel>
                <gri:panel>
                    #{dataTableStateHolder.setAscendingOn('variable')}
                    <rich:dataTable value="#{applicationPreferenceManager.getAllPreferences()}" var="pref"
                                    rows="#{dataScrollerMemory.numberOfResultsPerPage}" id="confTable" render="ds">
                        <g:column filterBy="#{'variable'}" sortBy="#{'variable'}" filterEvent="onkeyup"
                                  sortOrder="#{dataTableStateHolder.sortOrders['variable']}">
                            <ui:define name="header">#{messages['net.ihe.gazelle.simulator.common.PreferenceName']}</ui:define>
                            <rich:inplaceInput value="#{pref.variable}" showControls="true" inputWidth="90%">
                                <a4j:ajax event="change"
                                          listener="#{applicationPreferenceManager.savePreference(pref)}"
                                          render="globalDiv"/>
                            </rich:inplaceInput>
                        </g:column>

                        <g:column filterBy="#{'value'}" filterEvent="onkeyup">
                            <ui:define name="header">#{messages['net.ihe.gazelle.simulator.common.Value']}</ui:define>
                            <rich:inplaceInput value="#{pref.value}"
                                               defaultLabel="#{messages['net.ihe.gazelle.simulator.common.PreferenceValue_2']}"
                                               showControls="true" inputWidth="90%">
                                <a4j:ajax event="change"
                                          listener="#{applicationPreferenceManager.savePreference(pref)}"
                                          render="globalDiv"/>
                            </rich:inplaceInput>
                        </g:column>
                        <f:facet name="footer">
                            <ui:include src="/util/datatableFooter.xhtml">
                                <ui:param name="dataScrollerId" value="ds"/>
                                <ui:param name="dataTableId" value="confTable"/>
                            </ui:include>
                        </f:facet>
                    </rich:dataTable>
                    <f:facet name="footer">
                        <a4j:commandButton value="#{messages['net.ihe.gazelle.simulator.common.AddAPreference']}"
                                           actionListener="#{applicationPreferenceManager.createNewPreference()}"
                                           rendered="#{applicationPreferenceManager.preference == null}"
                                           render="globalDiv"
                                           styleClass="gzl-btn-green"/>
                        <!--  http headers Section -->
                        <a4j:commandButton action="#{applicationPreferenceManager.resetHttpHeaders()}"
                                           value="#{messages['gazelle.simu.SetDefaultHTTPHeaderValues']}"
                                           render="globalDiv" execute="@this" styleClass="gzl-btn-blue"/>
                        <a4j:commandButton action="#{applicationPreferenceManager.updateHttpHeaders()}"
                                           value="#{messages['gazelle.simu.UpdateHTTPSecurityPolicies']}"
                                           render="globalDiv" execute="@this" styleClass="gzl-btn-blue"/>
                    </f:facet>
                </gri:panel>
            </gzl:div>
        </h:form>
    </ui:define>
</ui:composition>
